import dash
import dash_cytoscape as cyto
import dash_html_components as html
import dash_core_components as dcc
from dash.dependencies import Input, Output, State
from copy import deepcopy

default_elements = [
    {'data': {'id': 'one', 'label': 'Node 1'}, 'position': {'x': 50, 'y': 50}},
    {'data': {'id': 'two', 'label': 'Node 2'}, 'position': {'x': 200, 'y': 200}},
    {'data': {'source': 'one', 'target': 'two', 'label': 'Node 1 to 2'}}
]

layout = {'name': 'grid'}

app = dash.Dash(__name__)
app.layout = html.Div([
    html.Button('Reset', id='bt-reset'),
    dcc.Slider(id='slider', min=0.5, max=2, step=0.1),
    cyto.Cytoscape(
        id='cytoscape',
        elements=default_elements,
        zoomingEnabled=True,
        zoom=2,
        layout=layout
    )
])

@app.callback(Output('cytoscape', 'zoom'),
              [Input('slider', 'value')])
def update_zoom(value):
    print(value)
    return value


# @app.callback(
#     [Output('cytoscape', 'zoom'),
#     Output('cytoscape', 'layout'),
#     Output('cytoscape', 'elements')],
#     [Input('bt-reset', 'n_clicks')],
#     [State('cytoscape', 'layout'),
#      State('cytoscape', 'zoom'),
#     State('cytoscape', 'elements')]
# )
# def reset_layout(n_clicks, layout, cy_zoom, elements):
#     print('click', n_clicks)
#     print(cy_zoom)
#
#     if n_clicks and n_clicks % 2:
#         layout = {'name': 'grid'}
#     else:
#         layout = {'name': 'circle'}
#
#     return [3, layout, elements]


if __name__ == '__main__':
    app.run_server(debug=True)